#include "shellscrollbar.h"
#include "sparrowshell.h"
#include "SparrowRenderer/mesh.h"
#include "SparrowRenderer/phongmaterial.h"
#include "scene/meshnode.h"
#include "tools/utils.h"
#include <iostream>


ShellScrollBar::ShellScrollBar(SparrowShell *shell):
    ScrollBarNode(
        glm::vec2(
            SparrowShell::SCROLLBAR_PIXEL_WIDTH,
            SparrowShell::DEFAULT_FONT_SIZE*SparrowShell::BUFFER_DISPLAYED_LINES
            ),
        glm::vec3(0,0,0.5)
        ),
    m_shell(shell)
{
    setBarSize(SparrowShell::BUFFER_DISPLAYED_LINES);
//    MeshNode(nullptr,false);
//    m_position = glm::vec2(m_shell->getDimension().x-SparrowShell::SCROLLBAR_PIXEL_WIDTH,0);
//    m_max_height = ;
//    m_dimension = glm::vec2(SparrowShell::SCROLLBAR_PIXEL_WIDTH, m_max_height);
//    moveTo2D(m_position);

//    Mesh* mesh = new Mesh();

//    mesh->addRectangle2D(glm::vec2(0),m_dimension);
//    PhongMaterial* mat = new PhongMaterial();
//    mat->diffuse = glm::vec3(0,0,0.5);
//    mat->m_opacity = 0.8;
//    mesh->setMaterial(mat);
//    mesh->setDepth(SparrowShell::SHELL_DEPTH+1);
//    mesh->initGL();
//    m_geometry.mesh = mesh;
}

void ShellScrollBar::update()
{
    if (m_shell->isBufferResized()){
        setSize(m_shell->getBuffer()->size());
    }
    if (m_shell->indexMoved())
    {
        setIndex(m_shell->getIndex());
    }
    ScrollBarNode::update();
}

